/**
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.project

import metridoc.utils.CollectionUtils.Maps

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 4/11/11
 * Time: 12:12 PM
 * To change this template use File | Settings | File Templates.
 */
@Mixin(IdSchemaGenerator.class)
class LoadingTableDefinition {
    def String name
    def Closure schema
    def delegate

    /**
     * make sure it is sorted so the generated columns are the same every time
     */
    def Map<String, ColumnDefinition> columns = Maps.createTreeMap()

    def column(args) {
        columns[args.name] = new ColumnDefinition(args)
    }

    def Closure getSchema(delegate) {
        if (schema == null) {
            schema = {
                changeSet(id: "${name}_loading", author: "metridoc") {
                    createTable(tableName: name) {
                        callIdSchema name, delegate
                        columns.each {name, column ->
                            def columnSchema = column.getSchema(delegate)
                            columnSchema()
                        }
                    }
                }
            }
        }

        return schema
    }
}
